<template>
  <div>
    <v-app>
      <template v-if="!isUserCookie">
        <v-row class="d-flex" justify="center">
          <v-col
            cols="12"
            sm="6"
            md="4"
            lg="3"
            xl="2"
            class="align-self-center"
          >
            <form @submit.prevent="login">
              <v-card>
                <v-card-title>
                  <v-icon>mdi-account-card-details-outline</v-icon>
                  <span class="ml-4">Login</span>
                </v-card-title>
                <v-card-text>
                  <v-row>
                    <v-col cols="12" sm="12" md="12" lg="12" xl="12">
                      Empleado
                      <span class="tRojo">*</span>
                      <v-text-field
                        maxlength="10"
                        flat
                        dense
                        placeholder="Empleado"
                        :error="$v.noEmpleado.$error"
                        v-model.trim.number="noEmpleado"
                        color="primary"
                      >
                        <template v-if="$v.noEmpleado.$error" v-slot:append>
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <div
                                @click="$v.noEmpleado.$reset"
                                v-close-popover
                              >
                                <div v-if="$v.noEmpleado.$error">
                                  *¡No te olvides de éste campo!
                                </div>
                              </div>
                            </template>
                          </v-popover>
                        </template>
                      </v-text-field>
                    </v-col>
                    <v-col
                      v-if="isErrorMasterKey"
                      cols="12"
                      sm="12"
                      md="12"
                      lg="12"
                      xl="12"
                    >
                      Clave
                      <span class="tRojo">*</span>
                      <v-text-field
                        maxlength="10"
                        flat
                        dense
                        type="password"
                        placeholder="Clave"
                        v-model.trim="clave"
                        color="primary"
                      >
                        <template v-if="$v.clave.$error" v-slot:append>
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <div @click="$v.clave.$reset" v-close-popover>
                                <div v-if="$v.clave.$error">
                                  *¡No te olvides de éste campo!
                                </div>
                              </div>
                            </template>
                          </v-popover>
                        </template>
                      </v-text-field>
                    </v-col>
                    <v-col
                      class="text-center pa-0"
                      cols="12"
                      sm="12"
                      md="12"
                      lg="12"
                      xl="12"
                      style="height : 10px"
                    >
                      <div v-if="isErrorAccess" class="text-right">
                        <span class="error--text">Datos incorrectos</span>
                        <v-icon x-large color="#fd5151"
                          >mdi-emoticon-neutral-outline</v-icon
                        >
                      </div>
                      <v-progress-circular
                        v-if="isLoading"
                        indeterminate
                        color="primary"
                      ></v-progress-circular>
                    </v-col>
                  </v-row>
                </v-card-text>
                <v-divider class="mt-5"></v-divider>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-slide-x-reverse-transition>
                    <v-btn
                      @click="
                        $v.$reset;
                        isErrorAccess = false;
                      "
                      icon
                      class="my-0"
                    >
                      <v-icon>mdi-refresh</v-icon>
                    </v-btn>
                  </v-slide-x-reverse-transition>
                  <v-btn
                    type="submit"
                    class="mr-5"
                    tile
                    large
                    :class="[{ desac: isLoading }, { desac: isErrorAccess }]"
                    depressed
                    color="primary"
                    >Entrar</v-btn
                  >
                </v-card-actions>
              </v-card>
            </form>
          </v-col>
        </v-row>
      </template>
      <div class="text-center">
        <v-overlay :value="isUserCookie">
          <v-progress-circular indeterminate size="115">
            Cargando información
            <v-icon>mdi-timer-sand</v-icon>
          </v-progress-circular>
        </v-overlay>
      </div>
      <v-footer app class="pa-0">
        <Version />
      </v-footer>
    </v-app>
  </div>
</template>
<script>
import axios from "axios";
const axiosPFA = store.state.axiosPFA;
import querystring from "querystring";
import store from "@/store";
import Version from "@/views/Version";
const serviceLocalStorage = store.state.serviceLocalStorage;
const serviceCommons = store.state.serviceCommons;
import router from "@/router";
import { required, requiredIf } from "vuelidate/lib/validators";
export default {
  name: "Component-AlternativeLogin",
  components: {
    Version
  },
  data() {
    return {
      noEmpleado: null,
      clave: null,
      isErrorMasterKey: false,
      showCache: false,
      isLoading: false,
      isErrorAccess: false,
      claves: ["1234567890", "0987654321"]
    };
  },
  validations: {
    noEmpleado: {
      required
    },
    clave: {
      required: requiredIf(function() {
        return this.isErrorMasterKey;
      })
    }
  },
  computed: {
    isUserCookie() {
      return serviceCommons.getCookie("user") !== "";
    },
    axiosPFA() {
      return store.state.axiosPFA;
    }
  },
  methods: {
    login() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        if (this.isErrorMasterKey) {
          this.isErrorAccess = !this.claves.includes(this.clave);
        }
        if (!this.isErrorAccess) {
          this.setCookie("user", this.noEmpleado, 2);
          this.getNewToken(this.noEmpleado);
        }
      }
    },
    registerSession(empleado) {
      axiosPFA
        .get("/session/register/" + empleado)
        .then((response) => {
          if (!response.data.current_access) {
            console.log("Conflicto al registrar la sesion");
            //store.state.dialogSessionFinish = true;
          } else {
            store.state.dialogSessionFinish = false;
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    getNewToken(empleado) {
      const self = this;
      const options = {
        method: "POST",
        data: querystring.stringify({
          username: empleado,
          password: empleado,
          grant_type: "password"
        }),
        headers: {
          "content-type": "application/x-www-form-urlencoded;charset=utf-8"
        },
        auth: {
          username: "frontendapp",
          password: "12345"
        },
        url: "/security/oauth/token"
      };
      this.isLoading = true;
      axios
        .request(options)
        .then((response) => {
         
          if (response && response.status === 200) {
            let response_token = response.data;
            if (
              response_token.status_code &&
              response_token.status_code == 401
            ) {
              self.isErrorAccess = true;
            } else {
              serviceLocalStorage.setToken(response_token);
              if (store.state.production) {
                self.registerSession(empleado);
              }
              store.state.isLogged = true;
              store.state.dialogSessionFinish = false;
              router.push({ name: "home" });
            }
          } else {
            self.isErrorAccess = true;
          }
        })
        .catch((error) => {
          self.isErrorAccess = true;
          console.log(error);
        })
        .finally(function() {
          self.deleteCookie("user");
          self.isLoading = false;
        });
    },
    getCookie(cname) {
      return serviceCommons.getCookie(cname);
    },
    setCookie(cname, cvalue, exdays) {
      serviceCommons.setCookie(cname, cvalue, exdays);
    },
    deleteCookie(cname) {
      serviceCommons.deleteCookie(cname);
    }
  },
  created() {
    const noEmpleado = this.getCookie("user");
    if (noEmpleado && noEmpleado !== "" && noEmpleado !== "null") {
      this.getNewToken(noEmpleado);
    }
    if (!store.state.isLogged && store.state.production) {
      const self = this;
      setTimeout(() => {
        self.showCache = true;
      }, 1000);
    }
  },
  beforeRouteEnter: function(to, from, next) {
    if (!store.state.isLogged) {
      next();
    } else {
      router.push({ name: "home" });
    }
  }
};
</script>
